import typing
from typing import Text, List, Any, Type
from rasa.nlu.tokenizers.tokenizer import Token, Tokenizer
from rasa.nlu.components import Component
from rasa.nlu.training_data import Message

class CustomTokenizer(Tokenizer, Component):

    defaults = {
        # Flag to check whether to split intents
        "intent_tokenization_flag": False,
        # Symbol on which intent should be split
        "intent_split_symbol": "_",
        # Regular expression to detect tokens
        "token_pattern": None,
    }
    
    def tokenize(self, message: Message, attribute: Text) -> List[Token]:
        tokens = message.text.split()
        print(tokens)
        final_tokens = [
            Token(text, message.text.index(text))
            for text in tokens
        ]

        return final_tokens